public class Factorielle {
		  public static void main(String[] args) {
			  try{
				  int input = Integer.parseInt(args[0]);
				  long resultat = factorielle(input);
				  System.out.println(input + "!=" + resultat);
			  } catch(NumberFormatException e)
			  {
				  System.err.println("Entrée incorrecte\n");
				  e.printStackTrace();
			  }
			  catch(PasDefini e)
			  {
				  System.err.println("Factorielle non définie : "+ e.getMessage());
			  }
		  }

		  public static long factorielle(int x) throws PasDefini 
		  {
			  if (x < 0)
				  throw new PasDefini("Valeur négative");
			  else
			  {
				  long fact = 1;
				  for(int i = 1; i <=x; i++)
					  if (fact > Long.MAX_VALUE / i)
						  throw new PasDefini("Dépassement de capacité");
					  else fact = fact * i;
				  return fact;
			  }
		  }
		}

class PasDefini extends Exception {
	public PasDefini(String s)
	{
		super(s);
	}
	
}